module detect_edge (
                     //out
					 detect_ext_int,
					 detect_nmi,
					 //in
					 pclk,
					 preset,
					 iscra,
					 iscrb,
					 mode_detect_nmi,
					 ext_event,
					 nmi_event
				   );

`include "address.v"
/*
*
*
*/
output[7:0]detect_ext_int;
output detect_nmi;
/*
*
*
*/
input pclk;
input preset;
input[7:0]iscra;
input[7:0]iscrb;
input[1:0]mode_detect_nmi;
input[7:0]ext_event;
input nmi_event;
/*
*
*
*/
wire[7:0]detect_ext_int;
wire detect_nmi;
reg[7:0]ext_event_s;
reg[7:0]ext_event_sff;
reg[7:0]ext_event_ff;
reg nmi_event_s;
reg nmi_event_sff;
reg nmi_event_ff;
/*
*
*
*/
/***************** synchoronous external signal ***************/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  ext_event_ff <= 8'h00;
	else
	  ext_event_ff <= ext_event;
  end

always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  ext_event_s <= 8'h00;
	else
	  ext_event_s <= ext_event_ff;
  end  
/*
*
*
*/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  nmi_event_ff <= 1'b0;
	else
	  nmi_event_ff <= nmi_event;
  end  
/*
*
*
*/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  nmi_event_s <= 1'b0;
	else
	  nmi_event_s <= nmi_event_ff;
  end
/*
*
*
*/
/*************** detect edge block ****************/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  nmi_event_sff <= 1'b0;
	else
	  nmi_event_sff <= nmi_event_s;
  end
  
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  ext_event_sff <= 8'h00;
	else
	  ext_event_sff <= ext_event_s;
  end  
/*
*
*
*/
assign detect_ext_int[0] = sense(iscra[1:0],ext_event_s[0],ext_event_sff[0]);
assign detect_ext_int[1] = sense(iscra[3:2],ext_event_s[1],ext_event_sff[1]);
assign detect_ext_int[2] = sense(iscra[5:4],ext_event_s[2],ext_event_sff[2]);
assign detect_ext_int[3] = sense(iscra[7:6],ext_event_s[3],ext_event_sff[3]);
assign detect_ext_int[4] = sense(iscrb[1:0],ext_event_s[4],ext_event_sff[4]);
assign detect_ext_int[5] = sense(iscrb[3:2],ext_event_s[5],ext_event_sff[5]);
assign detect_ext_int[6] = sense(iscrb[5:4],ext_event_s[6],ext_event_sff[6]);
assign detect_ext_int[7] = sense(iscrb[7:6],ext_event_s[7],ext_event_sff[7]);
assign detect_nmi = sense(mode_detect_nmi,nmi_event_s,nmi_event_sff);  
/*
*
*
*/
function sense;
  input[1:0]mode;
  input signal;
  input dsignal;
    begin
	  case(mode)
	  2'b00:sense = (~signal) & dsignal;                                  //falling edge
	  2'b01:sense =   signal  & (~dsignal);                               //rising edge
	  2'b10:sense =  ~signal;                                             //level "0"
	  2'b11:sense =  signal;                                              //level "1"
	  default:;
	  endcase
	end
endfunction

endmodule
 
 