module intc (
              //out
			  req_int,
			  vect_int,
			  prdata,
			  pslverr,
			  //in
			  pclk,
			  preset,
			  pwrite,
			  psel,
			  penable,
			  paddr,
			  pwdata,
			  i,
			  ext_event,
			  nmi_event,
			  irq_in
			);

`include "address.v"			
/*
*
*
*/
output req_int;
output[31:0]vect_int;
output[31:0]prdata;
output pslverr;
/*
*
*
*/
input pclk;
input preset;
input pwrite;
input psel;
input penable;
input[31:0]paddr;
input[31:0]pwdata;
input[1:0]i;
input[7:0]ext_event;
input nmi_event;
input[3:0]irq_in;
/*
*
*
*/
wire req_int;
wire[31:0]vect_int;
wire[31:0]prdata;
wire pslverr;
wire[1:0]mode_detect_nmi;
wire int_mode;
wire[7:0]iscra;
wire[7:0]iscrb;
wire[7:0]irq;
wire[7:0]ipra;
wire[7:0]iprb;
wire[7:0]iprc;
wire[7:0]iprd;
wire[7:0]ipre;
wire[7:0]iprf;				   
wire pclk;
wire preset;
wire pwrite;
wire psel;
wire penable;
wire[31:0]paddr;
wire[31:0]pwdata;
wire[7:0]detect_ext_int;
wire detect_nmi;
wire[7:0]ext_event;
wire nmi_event;
wire[11:0]matrix_to_arbiter;
wire[11:0]arbiter_to_decoder;
wire[3:0]irq_in;
/*
*
*
*/
/************ rwcontrol ****************/
rwcontrol rw (
			   //out
			   .pslverr(pslverr),             
			   .prdata(prdata),
			   .mode_detect_nmi(mode_detect_nmi),
			   .int_mode(int_mode),
			   .iscra(iscra),
			   .iscrb(iscrb),
			   .irq(irq),
			   .ipra(ipra),
			   .iprb(iprb),
			   .iprc(iprc),
			   .iprd(iprd),
			   .ipre(ipre),
			   .iprf(iprf),				   
			   //sys
			   .pclk(pclk),
			   .preset(preset),
			   //in
			   .pwrite(pwrite),
			   .psel(psel),
			   .penable(penable),
			   .paddr(paddr),
			   .pwdata(pwdata),
			   .detect_ext_int(detect_ext_int)			
			  );
/*
*
*
*/
/*************** detect_edge ****************/
detect_edge det (
				 //out
				 .detect_ext_int(detect_ext_int),
				 .detect_nmi(detect_nmi),
				 //in
				 .pclk(pclk),
				 .preset(preset),
				 .iscra(iscra),
				 .iscrb(iscrb),
				 .mode_detect_nmi(mode_detect_nmi),
				 .ext_event(ext_event),
				 .nmi_event(nmi_event)
				);               
/*
*
*
*/
/*************** priority_matrix **************/
priority_matrix priority_matrix0 (
								 //out
								  .out_reg(matrix_to_arbiter),
								 //in
								  .irq(irq),
								  .irq_in(irq_in),
								  .ipra(ipra),
								  .iprb(iprb),
								  .iprc(iprc),
								  .iprd(iprd),
								  .ipre(ipre),
								  .iprf(iprf)		
                                 );								  
/*
*
*
*/
/************** priority_arbiter ****************/
priority_arbiter priority_arbiter0 (				
									//out
									.grant(arbiter_to_decoder),
									//in
									.req(matrix_to_arbiter)
                                   );
/*
*
*
*/
/*************** priority_decoder *******************/
priority_decoder priority_decoder0 (
									//out
									.req_int(req_int),
									.vect_int(vect_int),
									//in
									.pclk(pclk),
									.preset(preset),
									.req(arbiter_to_decoder),
									.detect_nmi(detect_nmi),
									.i(i),
									.int_mode(int_mode)
                                   );				
/*
*
*
*/
endmodule								   