module priority_matrix (
                         //out
						 out_reg,
						 //in
						 irq,
						 irq_in,
						 ipra,
						 iprb,
						 iprc,
						 iprd,
						 ipre,
						 iprf			 
					   );

`include "address.v"
/*
*
*
*/
output[11:0]out_reg;
/*
*
*
*/
input[7:0]irq;
input[3:0]irq_in;
input[7:0]ipra;
input[7:0]iprb;
input[7:0]iprc;
input[7:0]iprd;	
input[7:0]ipre;
input[7:0]iprf;
/*
*
*
*/
wire[11:0]pri_row0;
wire[11:0]pri_row1;
wire[11:0]pri_row2;
wire[11:0]pri_row3;
wire[11:0]pri_row4;
wire[11:0]pri_row5;
wire[11:0]pri_row6;
wire[11:0]pri_row7;
wire[11:0]pri_row8;
wire[11:0]pri_row9;
wire[11:0]pri_row10;
wire[11:0]pri_row11;


reg[11:0]out_reg;
wire pri_colu0 = |pri_row0;
wire pri_colu1 = |pri_row1;
wire pri_colu2 = |pri_row2;
wire pri_colu3 = |pri_row3;
wire pri_colu4 = |pri_row4;
wire pri_colu5 = |pri_row5;
wire pri_colu6 = |pri_row6;
wire pri_colu7 = |pri_row7;
wire pri_colu8 = |pri_row8;
wire pri_colu9 = |pri_row9;
wire pri_colu10 = |pri_row10;
wire pri_colu11 = |pri_row11;
/*
*
*
*/
assign {pri_row11[0],pri_row10[0],pri_row9[0],pri_row8[0],pri_row7[0],pri_row6[0],pri_row5[0],pri_row4[0],pri_row3[0],pri_row2[0],pri_row1[0],pri_row0[0]} = shift(ipra[3:0],irq[0]);
assign {pri_row11[1],pri_row10[1],pri_row9[1],pri_row8[1],pri_row7[1],pri_row6[1],pri_row5[1],pri_row4[1],pri_row3[1],pri_row2[1],pri_row1[1],pri_row0[1]} = shift(ipra[7:4],irq[1]);
assign {pri_row11[2],pri_row10[2],pri_row9[2],pri_row8[2],pri_row7[2],pri_row6[2],pri_row5[2],pri_row4[2],pri_row3[2],pri_row2[2],pri_row1[2],pri_row0[2]} = shift(iprb[3:0],irq[2]);
assign {pri_row11[3],pri_row10[3],pri_row9[3],pri_row8[3],pri_row7[3],pri_row6[3],pri_row5[3],pri_row4[3],pri_row3[3],pri_row2[3],pri_row1[3],pri_row0[3]} = shift(iprb[7:4],irq[3]);
assign {pri_row11[4],pri_row10[4],pri_row9[4],pri_row8[4],pri_row7[4],pri_row6[4],pri_row5[4],pri_row4[4],pri_row3[4],pri_row2[4],pri_row1[4],pri_row0[4]} = shift(iprc[3:0],irq[4]);
assign {pri_row11[5],pri_row10[5],pri_row9[5],pri_row8[5],pri_row7[5],pri_row6[5],pri_row5[5],pri_row4[5],pri_row3[5],pri_row2[5],pri_row1[5],pri_row0[5]} = shift(iprc[7:4],irq[5]);
assign {pri_row11[6],pri_row10[6],pri_row9[6],pri_row8[6],pri_row7[6],pri_row6[6],pri_row5[6],pri_row4[6],pri_row3[6],pri_row2[6],pri_row1[6],pri_row0[6]} = shift(iprd[3:0],irq[6]);
assign {pri_row11[7],pri_row10[7],pri_row9[7],pri_row8[7],pri_row7[7],pri_row6[7],pri_row5[7],pri_row4[7],pri_row3[7],pri_row2[7],pri_row1[7],pri_row0[7]} = shift(iprd[7:4],irq[7]);
/*
*
*
*/
assign {pri_row11[8],pri_row10[8],pri_row9[8],pri_row8[8],pri_row7[8],pri_row6[8],pri_row5[8],pri_row4[8],pri_row3[8],pri_row2[8],pri_row1[8],pri_row0[8]} = shift(ipre[3:0],irq_in[0]);
assign {pri_row11[9],pri_row10[9],pri_row9[9],pri_row8[9],pri_row7[9],pri_row6[9],pri_row5[9],pri_row4[9],pri_row3[9],pri_row2[9],pri_row1[9],pri_row0[9]} = shift(ipre[7:4],irq_in[1]);
assign {pri_row11[10],pri_row10[10],pri_row9[10],pri_row8[10],pri_row7[10],pri_row6[10],pri_row5[10],pri_row4[10],pri_row3[10],pri_row2[10],pri_row1[10],pri_row0[10]} = shift(iprf[3:0],irq_in[2]);
assign {pri_row11[11],pri_row10[11],pri_row9[11],pri_row8[11],pri_row7[11],pri_row6[11],pri_row5[11],pri_row4[11],pri_row3[11],pri_row2[11],pri_row1[11],pri_row0[11]} = shift(iprf[7:4],irq_in[3]);
/*
*
*
*/
function [11:0]shift;
  input[3:0]ipr;
  input rq;
  begin
    case(ipr)
	4'h0:shift= { 12{rq} } & 12'h001;
	4'h1:shift= { 12{rq} } & 12'h002;
	4'h2:shift= { 12{rq} } & 12'h004;
	4'h3:shift= { 12{rq} } & 12'h008;
	4'h4:shift= { 12{rq} } & 12'h010;
	4'h5:shift= { 12{rq} } & 12'h020;
	4'h6:shift= { 12{rq} } & 12'h040;
	4'h7:shift= { 12{rq} } & 12'h080;
	4'h8:shift= { 12{rq} } & 12'h100;
	4'h9:shift= { 12{rq} } & 12'h200;
	4'ha:shift= { 12{rq} } & 12'h400;
	4'hb:shift= { 12{rq} } & 12'h800;
	default:shift= { 12{rq} } & 12'h000;
	endcase
  end
endfunction  
/*
*
*
*/
always @(*)
  begin
    if(pri_colu0)
	  out_reg <= pri_row0;
	else if(pri_colu1)
	  out_reg <= pri_row1;
	else if(pri_colu2)
	  out_reg <= pri_row2;
	else if(pri_colu3)
	  out_reg <= pri_row3;
	else if(pri_colu4)
	  out_reg <= pri_row4;
	else if(pri_colu5)
	  out_reg <= pri_row5;
	else if(pri_colu6)
	  out_reg <= pri_row6;
	else if(pri_colu7)
	  out_reg <= pri_row7;
	else if(pri_colu8)
	  out_reg <= pri_row8;	 
	else if(pri_colu9)
	  out_reg <= pri_row9;
	else if(pri_colu10)
	  out_reg <= pri_row10;
	else if(pri_colu11)
	  out_reg <= pri_row11;
    else
      out_reg <= 12'h000;	
  end
  /*
  *
  *
  */
  endmodule