module priority_decoder (
						  //out
				          req_int,
						  vect_int,
						  //in
						  pclk,
						  preset,
						  req,
						  detect_nmi,
						  i,
						  int_mode
						);

`include "address.v"
/*
*
*
*/
output req_int;
output[31:0]vect_int;
/*
*
*
*/
input pclk;
input preset;
input[11:0]req;
input detect_nmi;
input[1:0]i;
input int_mode;
/*
*
*
*/
reg req_int;
reg[31:0]vect_int;
/*
*
*
*/
/************ Gererate interrupt request to CPU *************/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  req_int <= 1'b0;
	else
	  req_int <= |req | detect_nmi;
  end  
/*
*
*
*/
/************ Generate interrupt address vector to CPU **************/
always @(posedge pclk or negedge preset)
  begin
    if(!preset)
	  vect_int <= 32'h00000000;
	else if(detect_nmi)
	  vect_int <= `nmi_vect;
	else if ( (i==2'b11) || (i==2'b01 && int_mode) )
	  case(req)
	  12'h001:vect_int <= `ex0_vect;
	  12'h002:vect_int <= `ex1_vect;
	  12'h004:vect_int <= `ex2_vect;
	  12'h008:vect_int <= `ex3_vect;
	  12'h010:vect_int <= `ex4_vect;
	  12'h020:vect_int <= `ex5_vect;
	  12'h040:vect_int <= `ex6_vect;
	  12'h080:vect_int <= `ex7_vect;	
	  12'h100:vect_int <= `in0_vect;
	  12'h200:vect_int <= `in1_vect;
	  12'h400:vect_int <= `in2_vect;
	  12'h800:vect_int <= `in3_vect;	  
	  default:vect_int <= vect_int;
	  endcase
  end  
/*
*
*
*/
endmodule  