module testtop;
/*
*
*
*/
wire req_int;
wire[7:0]vect_int;
wire[7:0]prdata;
wire pslverr;
wire pclk;
wire preset;
wire pwrite;
wire psel;
wire penable;
wire[3:0]paddr;
wire[7:0]pwdata;
wire[1:0]i;
reg[7:0]ext_event;
reg nmi_event;
reg[7:0]irq_in;
reg[31:0]test_status;
integer count=0;
/*
*
*
*/
`include "run_test.vt"
/*
*
*
*/
/*************** instantce file ******************/
/********** IP interrupt controller************/
intc intc0 (
             //out
			 .req_int(req_int),
		     .vect_int(vect_int),
		     .prdata(prdata),
			 .pslverr(pslverr),
			 //in
			 .pclk(pclk),
			 .preset(preset),
			 .pwrite(pwrite),
			 .psel(psel),
			 .penable(penable),
			 .paddr(paddr),
			 .pwdata(pwdata),
			 .i(i),
			 .ext_event(ext_event),
			 .nmi_event(nmi_event),
			 .irq_in(irq_in)
           );	
/************* cpumodel *********************/
cpumodel cpu (
					 //out
				     .pwrite(pwrite),
				     .psel(psel),
				     .penable(penable),
				     .paddr(paddr),
				     .pwdata(pwdata),
					 .i(i),
				     //in
				     .prdata(prdata),
				     .pclk(pclk),
				     .preset(preset)
				   );		   
/*************** generator ******************/
generator generator0 (
                       .pclk(pclk),
                       .preset(preset)
                     );
/*
*
*
*/
/************* simulation procedure ************/
initial
  begin
    test_status=32'hABAB_ABAB;
	#10;
	run_test;
	#100;
	report_test();
  end  
/*
*
*
*/
/************** task report_test ************/
task report_test;
  begin
    if (test_status == 32'hDEAD_DEAD) 
      begin
        report_fail();
      end
    else if(test_status == 32'hCAFE_CAFE) 
      report_pass();
  end
endtask
/************** task report_pass ***************/
task report_pass;
  begin
    $display("TEST_PASSED");
	#1000;
    $finish();
  end
endtask
/************* task report_fail *****************/
task report_fail;
  begin
    $display("TEST_FAILED");
	#1000;
    $finish();
  end
endtask  
/*
*
*
*/
/************** generate interrupt source ***************/
/************* multiple interrupt *****************/
initial
  begin
	ext_event=8'h00;
    wait(preset);
	ext_event=8'b0011_0000;
	#14000;
	ext_event=8'b1100_1111;
	#400;
	ext_event=8'b0011_0000;
  end

/************* single interrupt *******************
initial
  begin
    ext_event=8'h00;
	wait(preset);
	ext_event=8'b0011_0000;
	#13000;
	ext_event=8'b0011_0001;
	#400;
	ext_event=8'b0011_0000;
	#4000;
	ext_event=8'b0011_0010;
	#400;
	ext_event=8'b0011_0000;	
	#400;
	ext_event=8'b0011_0100;
	#400;
	ext_event=8'b0011_0000;
	#400;
	ext_event=8'b0011_1000;	
	#400;
	ext_event=8'b0011_0000;	
  end  */
  
initial
  begin
    nmi_event=1'b0;
	wait(preset);
	nmi_event=1'b0;
	#15000;
	nmi_event=1'b0;
	#400;
	nmi_event=1'b0;
  end 
  
initial
  begin
    irq_in=8'h00;
	wait(preset);
	irq_in=8'h00;
	#13000;
	irq_in=8'h00;
	#500;
	irq_in=8'h00;
  end   
/*
*
*
*/
endmodule  