module cpumodel (
				  //out
				  pwrite,
				  psel,
				  penable,
				  paddr,
				  pwdata,
				  i,
				  //in
				  prdata,
				  pclk,
				  preset
				);
/*
*
*
*/
output pwrite;
output psel;
output penable;
output[3:0]paddr;
output[7:0]pwdata;
output[1:0]i;
/*
*
*
*/
input[7:0]prdata;
input pclk;
input preset;
/*
*
*
*/
reg pwrite;
reg psel;
reg penable;
reg[3:0]paddr;
reg[7:0]pwdata;
reg[1:0]i;
/*
*
*
*/
/**************** khoi tao gia tri ban dau ******************/
initial
  begin
	wait(preset);
    paddr=4'hz;
    pwrite=1'bz;
    psel=1'b0;
    penable=1'b0;
    pwdata=8'hzz;
  end
/*
*
*
*/
/******************* task MOVT *****************************/
task MOVT;
input[3:0]paddr_movt;
input[7:0]pwdata_movt;
  begin
    @(posedge pclk)
    #1;
      begin
        pwrite=1'b1;
        psel=1'b1;
        paddr=paddr_movt;
        pwdata=pwdata_movt;
      end

    @(posedge pclk)
    #1;
      begin
        penable=1'b1;
      end

    @(posedge pclk)
    #1;
	$display("CPU write data 8'h%h complete into address 4'h%h",pwdata,paddr);
      begin
        paddr=4'hz;
        psel=1'b0;
        penable=1'b0;
        pwdata=8'hzz;
      end
  end
endtask 
/*
*
*
*/
/****************** task MOVF **************************/
task MOVF;
input[3:0]paddr_movf;
output[7:0]prdata_movf;

  reg[7:0]prdata_movf;

  begin
    @(posedge pclk)
    #1;
      begin
        pwrite=1'b0;
        psel=1'b1;
        paddr=paddr_movf;
      end

    @(posedge pclk)
    #1;
      begin
        penable=1'b1;
      end

    @(posedge pclk)
    prdata_movf=prdata;
    #1;
	$display("CPU read data 8'h%h complete from address 4'h%h",prdata,paddr);
      begin
        paddr=4'hz;
        psel=1'b0;
        penable=0;
      end 
  end
endtask
/*
*
*
*/
/***************task ui********************************/
task set_i;
  input[1:0]i_val;
  input integer cycle;
  begin
    while(cycle)
	  begin
	    @(posedge pclk)
		i <= i_val;
		cycle=cycle - 1;
	  end
	i<=2'b00;
  end
endtask
/*
*
*
*/
endmodule